<div id="header">
  <app-header></app-header>
</div>
<div class="container-fluid">
  <div id="content-wrapper" class="d-flex flex-row">
    <div id="sidebar"><app-sidebar></app-sidebar></div>
    <div id="main-container-gestionnaire-roles" class="container-fluid d-flex flex-column">
      <div id="title-container" class="container-fluid d-flex justify-content-between align-items-center p-4">
        <div class="dashboard-title d-flex flex-row align-items-center  p-5">
          <span><h1>GESTIONNAIRE DE GROUPES DE FONCTIONNALITES</h1></span>
        </div>
        <app-add-groupe-fonctionnalite-popup></app-add-groupe-fonctionnalite-popup>
      </div>

<!--##############################################################################""-->
<!--Add the search bar-->

<div class="mx-5 px-5 d-flex ">
  <button class="btn btn-outline-secondary me-2" type="button"
  data-bs-toggle="modal" data-bs-target="#filterRecherche">Filtre</button>
  <form class="d-flex"   >
    <input (ngModelChange)="search(key.value)" #key="ngModel" ngModel name="key" class="form-control me-2" type="search" placeholder="Search" aria-label="Search">
  </form>
  </div>


    <!-- Modal -->

    <form [formGroup]="form" (ngSubmit)="submit()" >
  <div class="modal fade" id="filterRecherche" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">

          <div class=" btn-group " role="group" aria-label="Basic radio toggle button group">

              <div class="me-2 ms-2">
                  <input formControlName="choix" value="actif" name="choix" type="radio" class="btn-check" name="btnradio" id="btnradio1" autocomplete="off" checked>
                  <label class="btn btn-outline-danger" for="btnradio1">Actif</label>
              </div>
              <div class="me-2 ms-2">
                  <input formControlName="choix" value="inactif" name="choix" type="radio" class="btn-check" name="btnradio" id="btnradio2" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="btnradio2">Inactif</label>
              </div>
              <div class="me-2 ms-2" >
                <input formControlName="choix" value="brouillon" name="choix" type="radio" class="btn-check" name="btnradio" id="btnradio3" autocomplete="off">
                <label class="btn btn-outline-warning" for="btnradio3">Brouillon</label>
            </div>
              <div class="me-2 ms-2">
                <input formControlName="choix" value="aucun" name="choix" type="radio" class="btn-check" name="btnradio" id="btnradio4" autocomplete="off">
                <label class="btn btn-outline-primary" for="btnradio4">Aucun</label>
            </div>
          </div>


          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
            <button type="submit" class="btn btn-primary" data-bs-dismiss="modal">Save changes</button>
          </div>
        </div>
      </div>
    </div>
  </form>

<!------------------>

      <div class="accordion accordion-flush" id="accordionFlushExample">
        <div class="accordion-item "
             *ngFor="let groupe of groupes; index as index "
             id="{{ groupe.id }}">
          <h2 class="accordion-header" id="flush-heading{{ groupe.id }}">
            <button class="accordion-button collapsed d-flex flex-row justify-content-between align-items-center "
                    type="button" data-bs-toggle="collapse"
                    [attr.data-bs-target]="'#flush-collapse' +
                    groupe.id " aria-expanded="false"
                    [attr.aria-controls]="'flush-collapse' +
                    groupe.id ">
              <div class="d-flex flex-row flex-grow-1 d-flex align-items-center">
                <span *ngIf="groupe.draft"
                      class="draft status d-flex align-items-center"
                      (click)="onConfirm($event, groupe)">brouillon</span>
                <span *ngIf="groupe.periodicite"
                      class="periodicite status d-flex align-items-center"
                      (click)="onSetPeriodicite($event, groupe)">{{ groupe.periodicite }}</span>
                <span *ngIf="!groupe.periodicite"
                      class="periodicite status d-flex align-items-center"
                      (click)="onSetPeriodicite($event, groupe)">indéterminée</span>
                <span *ngIf="!groupe.draft && !groupe.archive"
                      class="actif status d-flex align-items-center"
                      (click)="onDelete($event, groupe)">actif</span>
                <span *ngIf="!groupe.draft && groupe.archive"
                      class="inactif status d-flex align-items-center"
                      (click)="onDelete($event, groupe)">inactif</span>
                <!--<span class="plan-title d-flex align-items-center">{{ (groupe.nom.length>25)? (groupe.nom | slice:0:25)+'...':(groupe.nom) }}</span>-->
                <span class="plan-title d-flex align-items-center">{{ groupe.nom }}</span>
              </div>
              <div>
                <span class="edit" (click)="onClick($event, groupe)">
                  <i class="fa-solid fa-pen" aria-hidden="true"></i>
                </span>
                <!-- TODO: add link to dashboard-group: (click)="redirect('dashboard-groupe', groupe)"-->
                <span id="eye-button" (click)="navigateTo(groupe)">
                  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" (click)="navigateTo(groupe)">
                    <g>
                      <g fill="#231F20">
                        <path d="m34,256l26.2,26.2c108,108 283.7,108 391.7,0l26.1-26.2-26.2-26.2c-108-108-283.7-108-391.7,0l-26.1,26.2zm222,126.2c-75.8,0-151.6-28.9-209.3-86.6l-32.9-32.9c-3.7-3.7-3.7-9.7 0-13.5l32.9-32.9c115.4-115.4 303.2-115.4 418.6,0l32.9,32.9c3.7,3.7 3.7,9.7 0,13.5l-32.9,32.9c-57.7,57.7-133.5,86.6-209.3,86.6z"/>
                        <path d="m256,183.5c-40,0-72.5,32.5-72.5,72.5s32.5,72.5 72.5,72.5c40,0 72.5-32.5 72.5-72.5s-32.5-72.5-72.5-72.5zm0,164c-50.5,0-91.5-41.1-91.5-91.5 0-50.5 41.1-91.5 91.5-91.5s91.5,41.1 91.5,91.5c0,50.5-41,91.5-91.5,91.5z"/>
                      </g>
                    </g>
                  </svg>
                </span>
              </div>
            </button>
          </h2>
          <!--<div id="flush-collapse{{ groupe.id }}" class="accordion-collapse collapse"
               [attr.aria-labelledby]="'flush-heading' +
               groupe.id "
               data-bs-parent="#accordionFlushExample">
            <div class="accordion-body ">
              <h3>DETAILS</h3>
              <h4>{{ groupe.nom }} - <span>{{ plan.nom }}</span></h4>
              <p>
                <span *ngIf="groupe.periodicite != null">Périodicité : {{ groupe.periodicite }}</span>
                <span *ngIf="groupe.periodicite == null">Périodicité : indéterminée</span>
              </p>
            </div>
            <div class="accordion-body-bottom "></div>
          </div>-->
        </div>
      </div>
    </div>
  </div>
</div>
<!-- modal -->
<!-- Modal EDIT groupe-->
<div class="modal" id="myModal" [style.display]="showModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Détails du Groupe de fonctionnalités : {{editGroupe?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('editModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #editForm="ngForm" >
          <div class="form-group">
            <input
                   type="hidden"
                   ngModel="{{editGroupe?.id}}"
                   name="id"
                   id="id"
            />
            <input
                   type="hidden"
                   ngModel="{{editGroupe?.test_plan_plan_id}}"
                   id="test_plan_plan_id"
                   name="test_plan_plan_id"
            />
            <label class="mb-1" for="nom">Intitulé</label>
            <input
                   type="text"
                   ngModel="{{editGroupe?.nom}}"
                   id="nom"
                   name="nom"
                   class="form-control mb-2"
            />
          </div>
          <div class="form-group">
            <label for="periodicite" class="w-100 mb-1" >Périodicité</label>
            <select ngModel="{{editGroupe?.periodicite}}"
                    name="periodicite"
                    id="periodicite"
                    class="w-100"
            >
              <option value="1 mois"
                      [selected]="editGroupe?.periodicite == '1 mois'"
              >1 mois</option>
              <option
                value="2 mois"
                [selected]="editGroupe?.periodicite == '2 mois'"
              >2 mois</option>
              <option
                value="3 mois"
                [selected]="editGroupe?.periodicite == '3 mois'"
              >3 mois</option>
              <option
                value="4 mois"
                [selected]="editGroupe?.periodicite == '4 mois'"
              >4 mois</option>
              <option
                value="5 mois"
                [selected]="editGroupe?.periodicite == '5 mois'"
              >5 mois</option>
              <option
                value="6 mois"
                [selected]="editGroupe?.periodicite == '6 mois'"
              >6 mois</option>
              <option
                value="7 mois"
                [selected]="editGroupe?.periodicite == '7 mois'"
              >7 mois</option>
              <option
                value="8 mois"
                [selected]="editGroupe?.periodicite === '8 mois'"
              >8 mois</option>
              <option
                value="9 mois"
                [selected]="editGroupe?.periodicite == '9 mois'"
              >9 mois</option>
              <option
                value="10 mois"
                [selected]="editGroupe?.periodicite == '10 mois'"
              >10 mois</option>
              <option
                value="11 mois"
                [selected]="editGroupe?.periodicite == '11 mois'"
              >11 mois</option>
              <option
                value="12 mois"
                [selected]="editGroupe?.periodicite == '12 mois'"
              >12 mois</option>
            </select>
          </div>
          <div class="form-group">
            <label class="mb-1 me-2 w-100" for="draft">Etat :</label>
            <select ngModel="{{editGroupe?.draft}}"
                    name="draft"
                    id="draft"
                    class="w-100"
            >
              <option value="false"
                      [selected]="editGroupe?.draft === false"
              >achevé</option>
              <option
                value="true"
                [selected]="editGroupe?.archive === true"
              >brouillon</option>
            </select>
          </div>
          <div class="form-group">
            <label class="mb-1 me-2 w-100" for="archive">Status :</label>
            <select ngModel="{{editGroupe?.archive}}"
                    name="archive"
                    id="archive"
                    class="w-100"
            >
              <option value="false"
                      [selected]="editGroupe?.archive === false"
              >actif</option>
              <option
                      value="true"
                      [selected]="editGroupe?.archive === true"
              >inactif</option>
            </select>
          </div>
          <div class="mt-3 mb-2">
            <button class="btn btn-primary w-100" (click)="onSubmit(editForm.value)" [disabled]="editForm.invalid">Sauvegarder</button>
          </div>
          <div class="mt-2 mb-2">
            <button class="btn btn-secondary w-100" type="reset" (click)="hide('editModal')">Annuler</button>
          </div>
        </form>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal DELETE Plan-->
<div class="modal" id="deleteModal" [style.display]="showDeleteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Archiver : {{deleteGroupe?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('deleteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <div class="form-group">
          <p *ngIf="deleteGroupe?.archive == true" class="mt-3 mb-5" >Vous êtes sur le point d'activer le groupe de fonctionnalités {{deleteGroupe?.nom}}. <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
          <p *ngIf="deleteGroupe?.archive == false" class="mt-3 mb-5" >Vous êtes sur le point de désactiver le groupe de fonctionnalités {{deleteGroupe?.nom}}. <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
        </div>
          <div class="mt-3 mb-2">
            <button *ngIf="deleteGroupe?.archive == true" class="btn btn-danger w-100" (click)="onArchivePlan(deleteGroupe)" data-dismiss="modal">Activer</button>
            <button *ngIf="deleteGroupe?.archive == false" class="btn btn-danger w-100" (click)="onArchivePlan(deleteGroupe)" data-dismiss="modal">Désactiver</button>
          </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal SHOW PERIODICITE Plan-->
<div class="modal" id="setPeriodiciteModal" [style.display]="showPeriodiciteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Définir la périodicité : {{setPeriodicite?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('setPeriodiciteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #periodiciteForm="ngForm" >
          <div class="form-group">
            <label class="mb-1 me-2" for="periodicite">Périodicité :</label>
            <select ngModel="{{setPeriodicite?.periodicite}}"
                    name="periodicite"
                    id="periodicite"
            >
              <option value="1 mois"
                      [selected]="setPeriodicite?.periodicite == '1 mois'"
              >1 mois</option>
              <option
                value="2 mois"
                [selected]="setPeriodicite?.periodicite == '2 mois'"
              >2 mois</option>
              <option
                value="3 mois"
                [selected]="setPeriodicite?.periodicite == '3 mois'"
              >3 mois</option>
              <option
                value="4 mois"
                [selected]="setPeriodicite?.periodicite == '4 mois'"
              >4 mois</option>
              <option
                value="5 mois"
                [selected]="setPeriodicite?.periodicite == '5 mois'"
              >5 mois</option>
              <option
                value="6 mois"
                [selected]="setPeriodicite?.periodicite == '6 mois'"
              >6 mois</option>
              <option
                value="7 mois"
                [selected]="setPeriodicite?.periodicite == '7 mois'"
              >7 mois</option>
              <option
                value="8 mois"
                [selected]="setPeriodicite?.periodicite === '8 mois'"
              >8 mois</option>
              <option
                value="9 mois"
                [selected]="setPeriodicite?.periodicite == '9 mois'"
              >9 mois</option>
              <option
                value="10 mois"
                [selected]="setPeriodicite?.periodicite == '10 mois'"
              >10 mois</option>
              <option
                value="11 mois"
                [selected]="setPeriodicite?.periodicite == '11 mois'"
              >11 mois</option>
              <option
                value="12 mois"
                [selected]="setPeriodicite?.periodicite == '12 mois'"
              >12 mois</option>
            </select>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" (click)="onModifyPeriodicite(periodiciteForm.value)" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal ACTIVATE groupe-->
<div class="modal" id="activateModal" [style.display]="showActivateModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Activer le groupe de fonctionnalités : {{unDraftGroupe?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('activateModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #undraftForm="ngForm" >
          <div class="form-group">
            <p *ngIf="unDraftGroupe?.draft == true" class="mt-3 mb-5" >Vous êtes sur le point d'activer le groupe de fonctionnalités {{unDraftGroupe?.nom}}. <br/><br/>
              Êtes-vous sûr.e de vouloir continuer ?</p>
            <p *ngIf="unDraftGroupe?.draft == false" class="mt-3 mb-5" >Vous êtes sur le point de désactiver le groupe de fonctionnalités {{unDraftGroupe?.nom}}. <br/><br/>
              Êtes-vous sûr.e de vouloir continuer ?</p>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button *ngIf="unDraftGroupe?.draft == true" class="btn btn-danger w-100" (click)="onUndraft(unDraftGroupe)" data-dismiss="modal">Activer</button>
          <button *ngIf="unDraftGroupe?.draft == false" class="btn btn-danger w-100" (click)="onUndraft(unDraftGroupe)" data-dismiss="modal">Désactiver</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>
